###Generalized Recursive Logit GRL estimation
rm(list=ls(all=TRUE))
library(Matrix)
#########################################
############## Settings #################
#########################################

#ϐ1:N[m],2:E܉
binit <- rnorm(4) # initial value of the parameter
#R{N
inputdatapass<-"C:/workspace/RL_R/GRL_Dataset/data/output_neo/_reduced_route.csv"
inputlinkpass<-"C:/workspace/RL_R/GRL_Dataset/data/output_neo/network/reduced_link.csv"
inputmatrixpass<-"C:/workspace/RL_R/GRL_Dataset/data/output_neo/network/reduced_matrix.csv"
inputRigthpass<-"C:/workspace/RL_R/GRL_Dataset/data/output_neo/network/reduced_rightturn.csv"

readdata.number <- -1 # -1 = all
samplingdummy <- 0 # 1 = sampling , 0 = all
#sampling.number <- 100

############### time measure ############
message("PROGRAM START!\n")
t<-proc.time()


#########################################
########  reading & sampling    #########
#########################################


########## result data reading ##########
data <- read.csv(inputdatapass, nrows = readdata.number) #f[^ǂݍ
names(data) <- c("k","a","d")

if(samplingdummy == 1){
  spl <- sample( (1:nrow(data)), sampling.number )
  spldata <- data.frame("k"=c(-1),"a"=c(-1),"d"=c(-1))
  for(i in length(spl)){
    spldata <- rbind(spldata,data[spl,])
  }
  data <- subset(spldata,spldata$k>0)
}

ddata <- sort(unique(data$d)) #datadɂĐDuniqueŏdȂsortŐ񂳂ꂽd̒l݂̂̃f[^
kdata <- list()
dataList <- list() #z錾
for(i in 1:length(ddata)){ #I_d̎ނ̐JԂ
  sub <- subset(data,data$d == ddata[i]) #ddataisڂɑΉdƓ̂data璊osubɊi[
  kdata[[i]] <- sort(unique(sub$k)) #subkɂĐDuniqueŏdȂsortŐ񂳂ꂽk̒l݂̂̃f[^
  dataList[[i]] <- sub
} #̌JԂɂāCd̒lŐ񂳂ꂽdatad̒lƂdatalistɊi[Cɂ̂k̒l݂̂kdataɊi[Ă

kdata #edɑΉk̒li[Ă
dataList #d̒lɂĐ񂳂ꂽdataĂ
########## link data reading ############
link <- read.csv(inputlinkpass)
linkid <- sort(unique(link$LinkID))
L <- length(linkid)

########## link matrix reading ##########
matrix <- read.csv(inputmatrixpass) 
names(matrix) <- c("k","a")
asetdataList <-list()
matrixList <- list()

#NkɐڑĂ郊NãXg
AList <- list()
for(k in 1:L){
  kl <- linkid[k] #klinkID
  sub <- subset(matrix, matrix$k == kl)
  AList[[k]] <- sub$a #linkIDɑΉa𒊏o
}

################# index #################
dlength <- length(ddata)
llength <- length(link$LinkID)
D <- length(unique(data$d)) #ړIn
L <- length(linkid) #N

################# value function #################
V0 <- array(-1, dim = c(L, D)) #LsDŗvfׂ-1̍s.ׂẴNI_֍s܂ł̌ps
z0 <- exp(V0)

########### right turn dummy ############
Right <- read.csv(inputRigthpass) #, header=F
names(Right) <- c("k","a")

RR <- array(exp(0), dim = c(L, L))
for(s in 1:nrow(Right)){
  kl <- Right$k[s]
  al <- Right$a[s]
  k<-(1:length(linkid))[linkid == kl]
  a<-(1:length(linkid))[linkid == al]
  RR[k,a] <- exp(1)
}
RR <- as(RR, "sparseMatrix")
######### link connectiuon dummy ########
I <- array(0, dim = c(L, L))
names(matrix) <- c("k","a")
for(i in 1:nrow(matrix)){
  kl <- matrix$k[i] #Nڑsmatrixkisڂ̐lL
  al <- matrix$a[i] #Nڑsmatrixaisڂ̐lL
  k <- (1:L)[linkid == kl] #linkidŝklƓʒu1~L̂ŒT
  a <- (1:L)[linkid == al] #linkidŝalƓʒu1~L̂ŒT
  I[k,a] <- 1 #k,aɊYʒu̗אڍsI̒lOPɂ
}
Ilist <- list()
for(d in 1:D){ #d͑S60
  dl <- ddata[d] #I_N
  dn <- (1:L)[linkid == dl]
  #ړIn̐ڑsp?
  Id <- I
  #ړIn_~[͋z
  Id[dn, ] <- 0 #dnsׂ͂0ɂĂN_ƂȂ郊N
  #ړInɐڑĂ郊N͕KړInɑJ
  for(k in 1:L){
    aList <- AList[[k]] #NkɐڑĂ郊NãXg
    if(is.element(dl, aList)){ #k̎NãXgɏI_dl܂܂Ă
      Id[k, ] <- 0 #aɂ͍s
      Id[k, dn] <- 1 #I_ɂ̂ݐiނ̂Ƃ
    }
  }
  Ilist[[d]] <- Id
  #l֐ɂ
  V0[dn,d] <- 0 #I_̒`.I_I_ւ͌p0
  z0[dn,d] <- 1 #I_̒`
}

############ parameter init #############
b <- binit
V <- V0
z <- z0

tt <- array(exp(0), dim = c(1, L))
for(a in 1:L){
  tt[1,a] <- exp(0.6*(link$Length[a])/100) #N[km]ŌvZ
}

TT <- array(rep(tt), dim = c(L, L))
TT <- t(TT) #]uĂ TT[k,a] = tt[a] any k łΐ


#########################################
######## log-likelihood function ########
#########################################
fr <- function(x) {
  LL <- 0 
  
  for(d in 1:D){
    dn <- (1:L)[linkid == ddata[d]] #linkidsɂddata[d]ƓNID̉ӏLȉꍇlinkID͂Pn܂Ă̂ňʒulinkIDƂȂĂj
    #ڑs
    Id <- Ilist[[d]] #I_ɑΉNڑsDȂ킿̃\iڑȂPj
    #l֐
    #z <- array(exp(theta*V[,d]), dim = c(L, 1)) #I_dɑ΂eN̉l֐.zOK
    z <- array(exp(V[,d]), dim = c(L, 1)) #I_dɑ΂eN̉l֐.zOK
    ZD <-  array(rep(z), dim = c(L,L)) #zL񕡐
    ZD <- t(ZD) #]u
    M <- as(Id*(TT^x[1])*(RR^x[2]), "sparseMatrix") #eNԂ̌p֐(L*L) asŕۊ *AR
    #M <- Id*(TT^x[1])*(RR^x[2]) #eNԂ̌p֐(L*L)
    Mz <- (M%*%z != 0)*(M%*%z) + (M%*%z == 0)  #ł͂܂(L*L)%*%(L*1)=(L*1) NI_܂ł̌p֐
    
    Mz <- array(rep(Mz), dim = c(L,L)) #MzL񕡐(L*L) MZOK
    p <- (M*ZD)/Mz #NJڊm

    p <- (p == 0)*1 + (p != 0)*p
    
    klink <- dataList[[d]]$k
    alink <- dataList[[d]]$a
    #̃f[^
    hhd <- nrow(dataList[[d]])
    
    for(h in 1:hhd){
      k <- (1:L)[linkid == klink[h]] #linkid == klink[h]̂ƂɁCk1,2,...,Li[
      a <- (1:L)[linkid == alink[h]]
      if((alink[h] == ddata[d])){
        pka <- 1
      }else if(p[k,a] == 0){ #ifłTRUEFalsěʂԂȂƂȂ
        pka <- 1
      }else{
        pka <- p[k,a]
      }
      LL <- LL + log(pka)
    }
    #print(proc.time()-t)
  }
  return(LL)
}


b0 <- b

#########################################
############ value function #############
#########################################
newV <- function(x) { #l֐XV̂ߍēxݒ
  #theta <- exp(x[3])/(1+exp(x[3]))
  
  z <- matrix(1, nrow = L, ncol = D) #exp(Vd)̍s
  V <- array(0, dim = c(L, D)) #lƂĉlׂ͂0
  i <- 0
  for (d in 1:D){
    kd <- (1:length(linkid))[linkid == ddata[d]] #I_dł̂̈ʒu
    
    z[kd, d] <- 1 #I_I_͉l֐0C܂exp1
    
    M <- matrix(0, nrow = L, ncol = L) #exp(v)̍s
    B <- matrix(0, nrow = L, ncol = 1) #_~[N̂1̒lƂs
    B[kd, 1] <- 1
    
    #ڑsXV(Nkd͋z)
    Id <- Ilist[[d]]
    
    #sMi|A|~|A|j쐬
    for (k in 1:L){
      for (a in 1:L){
        Ika <- Id[k, a]
        if(Ika == 1){
          if(a == kd){ #郊NI_łƂ
            M[k, a] <- 1 #łI𑀍삵Ă̂őkɂĂ͎I00
          }else{
            #M[k, a] <- exp(x[1]*0.6*(link$Length[a]/link$Speed[a]) + x[2]*RR[k,a]
            M[k, a] <- exp(x[1]*0.6*link$Length[a]/100 + x[2]*RR[k,a])
          }
        } #else0Ȃ̂ŏȗ
      }
    } #for k
    
    #z̋tFCY
    dL <- 100
    zi <- matrix(z[,d], nrow = L, ncol = 1) #exp(V(d))
    while(dL > 1){ #dL\ɏȂ܂
      zii <- zi #z
      #Xz <- (zii)^theta #p֐̒g
      Xz <- zii #p֐̒g
      zi <- M %*% Xz + B #z̎XV
      dL <- sum(abs(zii - zi)) #zƍXVz̍
      cat("dL0=")
      print(dL) #G[`FbN
      
      i <- i + 1 #iXV
    } #while
    z[,d] <- zi #zXV
    zi <- (zi == 0)*1 + (zi != 0)*zi
    V[,d] <- log(zi) #VXV
  } #for d
  cat("i=")
  print(i)
  return(z)
}

#########################################
######### actual program area ###########
######### structural estimation ##########
#########################################
dL <- 100
n <- 0

while(dL>=1){
  n <- n + 1
  
  b0 <- b
  z <- z0
  V <- V0
  
  res <- optim(b0, fr, method = "Nelder-Mead", hessian = TRUE, control=list(fnscale=-1)) #̉l֐gčŖޖ@
  b <- res$par
  cat("b  =")
  print(b)
  cat("lnL=") #Lexp(l֐)
  print(res$value)
  #updating value funciton
  z0 <- newV(b) #Ŗޖ@œꂽ̂gĉl֐XV
  
  #convergence condition
dL <- sum(abs(V - V0)) + sum(abs(b - b0))
  zz <- (z == 0)*1 + (z != 0)*z
  V <- log(zz) #zz͌₷邾
  zz0 <- (z0 == 0)*1 + (z0 != 0)*z0
  V0 <- log(zz0) #zz0͌₷邾
  dL <- sum(abs(V - V0)) + sum(abs(b - b0)) #l֐̍{p[^l̍
  cat("dL =")
  print(dL)
}

hhh <- res$hessian
tval <- b/sqrt(-diag(solve(hhh)))
LL <- res$value
Vfin <- V0
#V <- array(0, dim = c(L, D))
#L0 <- fr(binit)
binit[3] <- b[3]
V <- newV(binit)
Lc <- fr(binit)

##########  estimation result ###########
print(res) #Ŗޖ@
print(Lc)  #
print(LL)
print((Lc-LL)/Lc) #ޓx
print((Lc-(LL-length(b)))/Lc) 
print(b) #p[^l
#theta <- exp(b[3])/(1+exp(b[3]))
#print(theta) #Ԋ
print(tval) #tl


########## calculation time #############
message("ALL COMPLETED!\n")
print(proc.time()-t)

